﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot		: False
	#ExcludeFromLibrary	: True
	
#End Region

Sub Process_Globals
	Public mControlIP					As String
	
	
	Public mConnectedMDBStarter			As Boolean
	Public mControlServerMDBStarter		As ServerSocket
	
	Private mClientMDBStarter			As Socket
	Private mAStreamMDBStarter			As AsyncStreams

	Private mListening 					As Boolean 			= True
	
	Private mFoundMDBStarter			As Boolean			= False
	Private mCheckingForMDBStarter		As Boolean			= False
	Private mWaitingForResponse			As Boolean			= False
	
	Private mMDBStarter_IPAddress		As String			= ""
	
	Private mSerializator				As B4XSerializator	
	
End Sub


Public  Sub Service_Create
			Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS	'.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves			
	
			mControlServerMDBStarter.Initialize(cControlCmds.StarterPORT, "ControlServerMDBStarter")
			
			mControlIP 	= mControlServerMDBStarter.GetMyWifiIP	
			mListening  = True
			
			ListenForConnections
End Sub

Public  Sub Service_Start(StartingIntent As Intent)

End Sub


Public  Sub Service_Destroy
			Log("ControlMDBStarter::Service_Destroy")
			
			Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
			
			CloseExistingConnection			
End Sub

Private Sub ListenForConnections
			Log("ControlMDBStarter::ListenForConnections")
	
			Do 	While mListening
				mControlServerMDBStarter.Listen
				
				Wait For ControlServerMDBStarter_NewConnection(Successful As Boolean, NewSocket As Socket)
				
				If 	Successful Then
					CloseExistingConnection
					
					mClientMDBStarter 	= NewSocket
					
					mAStreamMDBStarter.InitializePrefix(mClientMDBStarter.InputStream, False, mClientMDBStarter.OutputStream, "ControlMDBStarter_AStream")
					
					UpdateState(True)
				End If
			Loop
End Sub


Public  Sub ConnectToServerMDBStarter(Host As String) As ResumableSub
			Log("ControlMDBStarter::ConnectToServer -  Host:" &Host)
	
			CloseExistingConnection
			
			mClientMDBStarter.Initialize("ControlMDBStarter_Client")
			mClientMDBStarter.Connect(Host, cControlCmds.StarterPORT, 10000)
			
			Wait For ControlMDBStarter_Client_Connected(Successful As Boolean)
			
			If  Successful Then
				Log("ControlMDBStarter::ConnectToServer -  Connected")
				
				mAStreamMDBStarter.InitializePrefix(mClientMDBStarter.InputStream, False, mClientMDBStarter.OutputStream, "ControlMDBStarter_AStream")
	
				Return True
			Else
				Log("ControlMDBStarter::ConnectToServer -  Failed to connect: " & LastException)
				
				Return False
			End If
End Sub

Public  Sub Disconnect
			Log("ControlMDBStarter::Disconnect")
	
			CloseExistingConnection
End Sub

Public  Sub CloseExistingConnection
			Log("ControlMDBStarter::CloseExistingConnection")
	
'			SendCmd(cControlCmds.DEFINE_NotifyRemove, mControlServerMDBStarter.GetMyIP)	
			
			If  mAStreamMDBStarter.IsInitialized Then 
				mAStreamMDBStarter.Close
			End If
			
			If  mClientMDBStarter.IsInitialized Then 
				mClientMDBStarter.Close
			End If
			
			UpdateState(False)
End Sub

Private Sub UpdateState(Connected As Boolean)
			Log("ControlMDBStarter::UpdateState - Connected:" &Connected)
	
			mConnectedMDBStarter = Connected
			
'			If  SubExists(Main, "SetState") Then
'				CallSub2(Main, "SetState", mConnectedMDBStarter)
'			End If
End Sub

Private Sub ControlMDBStarter_AStream_Error
			Log("ControlMDBStarter::ControlMDBStarter_AStream_Error")
	
			UpdateState(False)
End Sub

Private Sub ControlMDBStarter_AStream_Terminated
			Log("ControlMDBStarter::ControlMDBStarter_AStream_Terminated")
			
			UpdateState(False)
End Sub

Private	Sub ControlMDBStarter_AStream_NewData(Buffer() As Byte)
			Log("ControlMDBStarter::ControlMDBStarter_AStream_NewData")
			
			Dim NewData			As Object 	= 	mSerializator.ConvertBytesToObject(Buffer)									
			Dim CommandReply	As TControlCmdReplyMsg
			
			If  NewData Is TControlCmdReplyMsg Then
				Log("ControlMDBStarter_AStream_NewData - Is TControlCmdReplyMsg")
				
				CommandReply = NewData
				
				If  mWaitingForResponse Then
					mWaitingForResponse = False
					
					If  mCheckingForMDBStarter Then
						Log("ControlMDBStarter_AStream_NewData - Checking for MDBStarter")
						
						If  CommandReply.Cmd = cControlCmds.DEFINE_Is_MDBStarter And CommandReply.CmdReply = cControlCmds.DEFINE_Reply_Yes Then
							Log("ControlMDBStarter_AStream_NewData - Found MDBStarter")
							cGenFuncs.MyToastMessageShow("Asking Start MusicDB  ", False, True, Colors.Yellow, Colors.Black, False)

					
							mFoundMDBStarter 		= True
							mCheckingForMDBStarter 	= False

							Log("ControlMDBStarter_AStream_NewData - Asking Starter to Start MusicDB")					
						
							SendCmd(cControlCmds.DEFINE_StartMusicDB, "")
						
							mWaitingForResponse		= True						
							Return
						End If
					End If
					
					If  mFoundMDBStarter Then			
						Log("ControlMDBStarter_AStream_NewData - Starter Reply to StartMusicDB")
						
						cGenFuncs.MyToastMessageShow("Started MusicDB  ", False, True, Colors.Yellow, Colors.Black, False)
						
						If  CommandReply.Cmd = cControlCmds.DEFINE_StartMusicDB And CommandReply.CmdReply = cControlCmds.DEFINE_Reply_Started Then
							If  SubExists(Main, "FindMusicDB")  Then
								CallSub(Main, "FindMusicDB")							
							End If
						End If
						
						Return
					End If
				End If				
'			else if NewData Is TControlNotifyInfo Then
'					Dim OldDataType As TControlNotifyInfo			= NewData
'					Dim NewDataType As TControlNotifyPlayingInfo
'					
'					NewDataType.Initialize
'					NewDataType.Album		= OldDataType.Album
'					NewDataType.Artist		= OldDataType.Artist
'					NewDataType.CoverAt		= OldDataType.CoverAt
'					NewDataType.IsPlaying	= OldDataType.IsPlaying
'					NewDataType.Song		= OldDataType.Song
'					NewDataType.Time		= OldDataType.Time
'					NewDataType.TrackID		= OldDataType.TrackID
'					
'					CallSub2(Main, "NotifyInfo", NewDataType)
'					Return													
			else if NewData Is TControlNotifyPlayingInfo Or NewData Is TControlNotifyFavoritesInfo Then
					If  SubExists(Main, "NotifyInfo") Then
						CallSub2(Main, "NotifyInfo", NewData)
					End If
					
					Return
			End If
			
			CallSub2(Main, "CmdReply", CommandReply)
End Sub

Public  Sub SendCmd(Cmd As String, CmdParm As String)
			Log("ControlMDBStarter::SendCmd  Cmd:" &Cmd &"  Parm:" &CmdParm)
			
			If  mConnectedMDBStarter Then 
				Dim Command As TControlCmd
				
				Command.Initialize
				Command.Cmd		= Cmd
				Command.CmdParm	= CmdParm
				
				mAStreamMDBStarter.Write(mSerializator.ConvertObjectToBytes(Command))
			End If
End Sub

Public  Sub FindConnection(WiFi_Address As String)
			Log("ControlMDBStarter::FindConnection - IP:" &WiFi_Address)
												
			mMDBStarter_IPAddress = WiFi_Address												
												
			wait for (ConnectToServerMDBStarter(mMDBStarter_IPAddress)) Complete(Connected As Boolean)
				
			'------------------------------------------------------------------
			'  Found someone we can connect to?				
			'------------------------------------------------------------------
			If  Connected Then
				cGenFuncs.MyToastMessageShow("Connection Made MDBStarter?  ", False, True, Colors.Yellow, Colors.Black, False)
				
				Log("ControlMDBStarter::FindConnection - Connected")
				
				mConnectedMDBStarter	= True				
				mCheckingForMDBStarter 	= True
				mWaitingForResponse 	= True
				'--------------------------------------------------------------
				'  See if it MDBStarter
				'--------------------------------------------------------------
				SendCmd(cControlCmds.DEFINE_Is_MDBStarter, "")
					
				do  while mWaitingForResponse
					Sleep(0)
				Loop
					
				If  mFoundMDBStarter Then
					UpdateState(True)
				End If
				
				Return
			End If
			
			'------------------------------------------------------------------
			'  We DID Not connect to MDBStarter so see if we can find MDBStarter
			'------------------------------------------------------------------			
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Public  Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
			Return True
End Sub
