﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot		: False
	#ExcludeFromLibrary	: True
	
#End Region

Sub Process_Globals
	Public mControlIP					As String
	
	
	Public mConnectedMusicDB			As Boolean
	Public mControlServerMusicDB		As ServerSocket
	
	Private mClientMusicDB				As Socket
	Private mAStreamMusicDB				As AsyncStreams

	Private mListening 					As Boolean 			= True
	
	Private mFoundMusicDB				As Boolean			= False
	Private mCheckingForMusicDB			As Boolean			= False
	Private mWaitingForResponse			As Boolean			= False

	Private mMusicDB_IPAddress			As String			= ""
	
	Private mSerializator				As B4XSerializator	
	
End Sub


Public  Sub Service_Create
			Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS	'.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves			
	
			mControlServerMusicDB.Initialize(cControlCmds.MusicDBPORT, "ControlServerMusicDB")
			
			mControlIP 	= mControlServerMusicDB.GetMyWifiIP	
			mListening  = True
			
			Log("ControlMusicDB::Service_Create - WiFiIP:" &mControlServerMusicDB.GetMyWifiIP &"  IP:" &mControlServerMusicDB.GetMyIP)
						
			ListenForConnections
End Sub

Public  Sub Service_Start(StartingIntent As Intent)

End Sub


Public  Sub Service_Destroy
			Log("ControlMusicDB::Service_Destroy")
			
			Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
			
			CloseExistingConnection			
End Sub

Private Sub ListenForConnections
			Log("ControlMusicDB::ListenForConnections")
	
			Do 	While mListening
				mControlServerMusicDB.Listen
				
				Wait For ControlServerMusicDB_NewConnection(Successful As Boolean, NewSocket As Socket)
				
				If 	Successful Then
					CloseExistingConnection
					
					mClientMusicDB 	= NewSocket
					
					mAStreamMusicDB.InitializePrefix(mClientMusicDB.InputStream, False, mClientMusicDB.OutputStream, "ControlMusicDB_AStream")
					
					UpdateState(True)
				End If
			Loop
End Sub


Public  Sub ConnectToServerMusicDB(Host As String) As ResumableSub
			Log("ControlMusicDB::ConnectToServer -  Host:" &Host)
	
			CloseExistingConnection
			
			mClientMusicDB.Initialize("ControlMusicDB_Client")
			mClientMusicDB.Connect(Host, cControlCmds.MusicDBPORT, 10000)
			
			Wait For ControlMusicDB_Client_Connected(Successful As Boolean)
			
			If  Successful Then
				Log("ControlMusicDB::ConnectToServer -  Connected")
				
				mAStreamMusicDB.InitializePrefix(mClientMusicDB.InputStream, False, mClientMusicDB.OutputStream, "ControlMusicDB_AStream")
	
				Return Successful
			Else
				Log("ControlMusicDB::ConnectToServer -  Failed to connect: " & LastException)

				Return Successful				
			End If
End Sub

Public  Sub Disconnect
			Log("ControlMusicDB::Disconnect")
	
			CloseExistingConnection
End Sub

Public  Sub CloseExistingConnection
			Log("ControlMusicDB::CloseExistingConnection")
	
			SendCmd(cControlCmds.DEFINE_NotifyRemove, mControlServerMusicDB.GetMyIP)	
			
			If  mAStreamMusicDB.IsInitialized Then 
				mAStreamMusicDB.Close
			End If
			
			If  mClientMusicDB.IsInitialized Then 
				mClientMusicDB.Close
			End If
			
			UpdateState(False)
End Sub

Private Sub UpdateState(Connected As Boolean)
			Log("ControlMusicDB::UpdateState - Connected:" &Connected)
	
			mConnectedMusicDB = Connected
			
			If  SubExists(Main, "SetState") Then
				CallSub2(Main, "SetState", mConnectedMusicDB)
			End If
End Sub

Private Sub ControlMusicDB_AStream_Error
			Log("ControlMusicDB::ControlMusicDB_AStream_Error  - [" &LastException &"]")
		
			'----------------------------------------------------------------------------------
			'  FOR some reason I have not figured out why yet in Android version 5.1.1
			'	    I get this stream error which causes me to think the connection has been
			'		lost and it really isn't.  So for the right now I ignore it.
			'----------------------------------------------------------------------------------
			If  LastException.Message.Contains("EBADF (Bad file number)") Then
				Return
			End If
			
			UpdateState(False)
End Sub

Private Sub ControlMusicDB_AStream_Terminated
			Log("ControlMusicDB::ControlMusicDB_AStream_Terminated")
			
'			UpdateState(False)
End Sub

Private	Sub ControlMusicDB_AStream_NewData(Buffer() As Byte)
			Log("ControlMusicDB::ControlMusicDB_AStream_NewData")
			
			Dim NewData			As Object 	= 	mSerializator.ConvertBytesToObject(Buffer)									
			Dim CommandReply	As TControlCmdReplyMsg
			
			If  NewData Is TControlCmdReplyMsg Then
				Log("ControlMusicDB_AStream_NewData - Is TControlCmdReplyMsg")
				
				CommandReply = NewData
				
				If  mCheckingForMusicDB Then
					If  CommandReply.Cmd = cControlCmds.DEFINE_Is_MusicDB And CommandReply.CmdReply = "Yes" Then
						Log("Found MusicDB")
						cGenFuncs.MyToastMessageShow("Connected to MusicDB  ", False, True, Colors.Magenta, Colors.White, False)						
					
						mFoundMusicDB 		= True
						mWaitingForResponse = False
						mCheckingForMusicDB = False
					
						SendNotifyMe
						Return
					Else
						Log("ControlMusicDB_AStream_NewData - Could NOT Connect with MusicDB - See if we can find MDBStarter")
						
						If  SubExists(ControlMDBStarter, "FindConnection") Then
							CallSub2(ControlMDBStarter, "FindConnection", mMusicDB_IPAddress)
						End If
					End If
				else if CommandReply.Cmd = cControlCmds.DEFINE_Status_VolumeIs Then
						Log("ControlMusicDB_AStream_NewData - Is TControlCmdReplyMsg - VolumeIs[" &CommandReply.CmdReply &"]")
						
						If  IsNumber(CommandReply.CmdReply) Then
							CallSub2(Main, "VolumeLevelIs", CommandReply.CmdReply)
						End If
				End If				
'			else if NewData Is TControlNotifyInfo Then
'					Dim OldDataType As TControlNotifyInfo			= NewData
'					Dim NewDataType As TControlNotifyPlayingInfo
'					
'					NewDataType.Initialize
'					NewDataType.Album		= OldDataType.Album
'					NewDataType.Artist		= OldDataType.Artist
'					NewDataType.CoverAt		= OldDataType.CoverAt
'					NewDataType.IsPlaying	= OldDataType.IsPlaying
'					NewDataType.Song		= OldDataType.Song
'					NewDataType.Time		= OldDataType.Time
'					NewDataType.TrackID		= OldDataType.TrackID
'					
'					CallSub2(Main, "NotifyInfo", NewDataType)
'					Return									
			else if NewData Is TControlNotifyPlayingInfo Or NewData Is TControlNotifyFavoritesInfo Then
					Log("ControlMusicDB_AStrieam_NewData - Is TControlNotifyPlayingInfo or Is TControlNotifyFavoritesInfo")
				
					CallSub2(Main, "NotifyInfo", NewData)
					Return				
			End If
			
			CallSub2(Main, "CmdReply", CommandReply)
End Sub

Public  Sub SendCmd(Cmd As String, CmdParm As String)
			Log("ControlMusicDB::SendCmd  Cmd:" &Cmd &"  Parm:" &CmdParm)
			
			If  mConnectedMusicDB Then 
				Dim Command As TControlCmd
				
				Command.Initialize
				Command.Cmd		= Cmd
				Command.CmdParm	= CmdParm
				
				mAStreamMusicDB.Write(mSerializator.ConvertObjectToBytes(Command))
			End If
End Sub

Public  Sub SendNotifyMe
			Log("ControlMusicDB::SendNotifyMe")
			
			If  mConnectedMusicDB Then
				Dim Cmd As TControlCmd
				
				Cmd.Initialize
				Cmd.Cmd 	= cControlCmds.DEFINE_NotifyMe
				Cmd.CmdParm	= mControlServerMusicDB.GetMyIP
				
				mAStreamMusicDB.Write(mSerializator.ConvertObjectToBytes(Cmd))
			End If
End Sub

Public  Sub FindConnection(WiFi_Address As String)
			Log("ControlMusicDB::FindConnection - IP:" &WiFi_Address)
												
			mMusicDB_IPAddress = WiFi_Address												
												
			wait for (ConnectToServerMusicDB(mMusicDB_IPAddress)) Complete(Connected As Boolean)
				
			'------------------------------------------------------------------
			'  Found someone we can connect to?				
			'------------------------------------------------------------------
			If  Connected Then
				cGenFuncs.MyToastMessageShow("Connection to MusicDB?  ", False, True, Colors.Magenta, Colors.White, False)
				
				Log("ControlMusicDB::FindConnection - Connected")
				
				mConnectedMusicDB	= True
				
				mCheckingForMusicDB = True
				mWaitingForResponse = True
				'--------------------------------------------------------------
				'  See if it MusicDB
				'--------------------------------------------------------------
				SendCmd(cControlCmds.DEFINE_Is_MusicDB, "")
					
				do  while mWaitingForResponse
					Sleep(0)
				Loop
					
				If  mFoundMusicDB Then					
					UpdateState(True)
				End If
				
				Return
			End If


			Log("ControlMusicDB::FindConnection - NOT Connected")
			
			'------------------------------------------------------------------
			'  We DID Not connect to MusicDB so see if we can find MDBStarter
			'------------------------------------------------------------------						
			CallSub2(ControlMDBStarter, "FindConnection", WiFi_Address)
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Public  Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
			Return True
End Sub
