﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.8
@EndOfDesignText@
Sub Process_Globals
    Type sReturnInfo(AOK As Boolean, Reason As String, RC As Int)

    Public  IsInitialized    					As Boolean = False

    Private mAlertBeeper      					As Beeper

    Private mB64Image                           As Base64Convert

    Private ReturnInfo       					As sReturnInfo
	

End Sub

#Region Initialize
Public  Sub Initialize
		    IsInitialized = True
			
    		mB64Image.Initialize

		    mAlertBeeper.Initialize2(500, 500, mAlertBeeper.VOLUME_NOTIFICATION)
End Sub
#End Region

#Region AlertBeeper
Public  Sub AlertBeeper
			mAlertBeeper.Beep	
End Sub
#end Region

#Region CreateDirectories / CreateDirectory / DoesFileExist
Public  Sub CreateDirectories(DirectoriesToCreate() As String) As Boolean

    		ReturnInfo.Initialize
			
			For i = 0 To DirectoriesToCreate.Length-1
    			ReturnInfo = CreateDirectory(DirectoriesToCreate(i))

    			If  ReturnInfo.AOK = False Then
       				'MessageBox("Unable to create directory:" &DirectoriesToCreate(i) &" - " &ReturnInfo.Reason, "Create Directories")
       				Return False
    			End If
			Next 

    		Return True
End Sub

Public Sub CreateDirectory(Directory As String) As sReturnInfo

        	Dim ReturnInfo As sReturnInfo

        	ReturnInfo.Initialize
        	ReturnInfo.AOK = True

        	Try
            	File.MakeDir(File.DirRootExternal, Directory)

            	ReturnInfo.Reason = File.DirRootExternal &"/" &Directory
        	Catch
            	ReturnInfo.Reason = "Unable to create directory: " &Directory &"  Reason: " &LastException.Message
            	ReturnInfo.AOK    = False
        	End Try

        	Return ReturnInfo
End Sub
#end region

Public  Sub DoesFileExist(Directory As String, FileName As String) As Boolean
	
    		Return File.Exists(File.DirRootExternal, Directory &FileName)
End Sub

Public  Sub DeleteFile(Directory As String, FileName As String) As Boolean
    		Return File.Delete(File.DirRootExternal, Directory &FileName)
End Sub


#Region CreateScaledBitmap 
Private Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
  			Dim jo As JavaObject
			
  			jo.InitializeStatic("android.graphics.Bitmap")
  			Return jo.RunMethod("createScaledBitmap", Array (Original, Width, Height, Filter))
End Sub
#end Region

#Region LoadThisBitmap / LoadThisBitmapDrawable
Public  Sub LoadThisBitmap(BitmapName As String) As Bitmap

    		Dim LoadedBitmap As Bitmap

    		LoadedBitmap = LoadBitmap(File.DirAssets, BitmapName)

	#If DebugX
    		Log(BitmapName &": " &LoadedBitmap.Width &" " &LoadedBitmap.Height)
	#End If
	
    		Return LoadedBitmap
End Sub

Public  Sub LoadThisBitmapDrawable(BitmapName As String) As BitmapDrawable

    		Dim LoadedBitmapDrawable  As BitmapDrawable

    		LoadedBitmapDrawable.Initialize(LoadThisBitmap(BitmapName))

    		Return LoadedBitmapDrawable
End Sub
#end Region


#Region MakeBitmapFromString
Public  Sub MakeBitmapFromString(BitmapString As String) As BitmapDrawable

			Dim BD			As BitmapDrawable
    		Dim DDBitmap 	As Bitmap
		
    		Dim Bmp      	As Bitmap
            Dim lv 		 	As LayoutValues = GetDeviceLayoutValues

			Bmp 			= mB64Image.DecodeToImage(BitmapString)
			DDBitmap	 	= CreateScaledBitmap(Bmp, Bmp.Width * lv.Scale, Bmp.Height * lv.Scale, True)
				
			BD.Initialize(DDBitmap)
			
			Return BD	
End Sub
#end Region

#Region MakeDrawableBitmap
Public  Sub MakeDrawableBitmap(CoverArt As Object)  As BitmapDrawable
	
			If  CoverArt Is BitmapDrawable Then
				Return CoverArt
			End If
			
			If  CoverArt Is Bitmap Then
				Dim BD	As BitmapDrawable
				
				BD.Initialize(CoverArt)
				
				Return BD
			End If
			
			
			Return Null			
End Sub
#end Region

#region MakeColorDrawable
Sub MakeColorDrawable(BackgroundColor As Int, CornerRadius As Int, BorderWidth As Int, BorderColor As Int) As ColorDrawable
	
	Dim MakeCD As ColorDrawable

	MakeCD.Initialize2(BackgroundColor, CornerRadius, BorderWidth, BorderColor)
	
	Return MakeCD
End Sub	
#end region

#Region MakeStateListBitmap
Public  Sub MakeStateListBitmap(StateListOptions() As Object) As StateListDrawable

			Dim StateList	   	As StateListDrawable
	
			StateList.Initialize
			
			If  StateListOptions.Length < 2 Then 
				Return StateList
			End If
			
			Dim SLCmd			As String = StateListOptions(0)
			
			SLCmd = SLCmd.Trim
			
			If  SLCmd.Length < (StateListOptions.Length-1) Then 
				Return StateList
			End If

			SLCmd = SLCmd.ToLowerCase			
			
			For i = 0 To SLCmd.Length-1				
				Dim SLBitmap   	As BitmapDrawable
				
				If  StateListOptions(i+1) Is Bitmap Then						
					SLBitmap.Initialize(StateListOptions(i+1))
				else if StateListOptions(i+1) Is String Then
					SLBitmap = LoadThisBitmapDrawable(StateListOptions(i+1))
				Else
					Return StateList
				End If
				
					
				Select SLCmd.CharAt(i)
				  Case "c"
				  		StateList.AddState(StateList.State_Checked, SLBitmap)
							
				  Case "u"
				  		StateList.AddState(StateList.State_Unchecked, SLBitmap)
							
				  Case "d"
					   StateList.AddState(StateList.State_Disabled, SLBitmap)
								
				  Case "p"
					    StateList.AddState(StateList.State_Pressed, SLBitmap)
								
				  Case "e"
					    StateList.AddState(StateList.State_Enabled, SLBitmap)
				  End Select
			Next
			
			Return StateList
End Sub
#end Region


#Region MarqueeTextForever / MarqueeText
Sub MarqueeTextForever(DisplayField As Object)  
	MarqueeText(DisplayField, -1)  
End Sub

Sub MarqueeText(DisplayField As Object, LimitTo As Int)
    Dim Ref As Reflector

    Ref.Target = DisplayField

    Ref.RunMethod2("setLines", 1, "java.lang.int")
    Ref.RunMethod2("setHorizontallyScrolling", True, "java.lang.boolean")

    Ref.RunMethod2("setEllipsize", "MARQUEE", "android.text.TextUtils$TruncateAt")
    Ref.RunMethod2("setSelected", True, "java.lang.boolean")

    If LimitTo == 0 Then
       LimitTo = -1
    End If

    Ref.RunMethod2("setMarqueeRepeatLimit", LimitTo, "java.lang.int")
End Sub
#end Region 

#Region MyToastMessageShow
Public  Sub MyToastMessageShow(Text As Object, LongDuration As Boolean, Center As Boolean, BackgroundColor As Int, TextColor As Int, Alert As Boolean)
		    Dim toast 		As JavaObject
	
    		Dim ctxt 		As JavaObject
		    Dim duration 	As Int
			
    		ctxt.InitializeContext
			
    		If  LongDuration Then 
				duration = 1 
			Else 
				duration = 0
			End If
			
			Dim cs As CSBuilder
			
			cs.Initialize.Typeface(Typeface.CreateNew(Typeface.MONOSPACE, Typeface.STYLE_ITALIC)).Bold.Color(TextColor).Size(16).Append(Text &" ").PopAll

    		toast = toast.InitializeStatic("android.widget.Toast").RunMethod("makeText", Array(ctxt, cs, duration))
			
    		Dim v 	As View = toast.RunMethod("getView", Null)
    		
			v.Background = MakeColorDrawable(BackgroundColor, 5dip, 2dip, TextColor)
  
  			If  Center Then
    			toast.RunMethod("setGravity", Array(Bit.Or(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL), 0, 0))
			End If
			
			If  Alert Then
				AlertBeeper
			End If
			
    		toast.RunMethod("show", Null)
End Sub
#end Region

#Region MsgBoxWithReply
Public  Sub MsgBoxWithReply(Msg As String, Title As String, LeftButton As String, CenterButton As String, RightButton As String, BitmapICON As Bitmap, Alert As Boolean) As Int
    		Dim MyMsg        As Msgbox3
    		Dim Result       As Int				= 0
'			Dim MyDialog 	 As CustomDialog2



			Dim PassedBitmap As Object


			If BitmapICON.IsInitialized Then 
			   PassedBitmap = BitmapICON
			Else
			   PassedBitmap = Null
			End If

			If Alert Then AlertBeeper

'			Result = MyDialog.Show((Msg, Title, RightButton, CenterButton, LeftButton, PassedBitmap)


    		Result = MyMsg.Show(Msg, Title, RightButton, CenterButton, LeftButton, PassedBitmap)
			
'			"No", "", "Yes", Null)
'           -1    -3    -2
'           Cancel  No    Yes	

'ToastMessageShow("Retuning:" &Result, False)

			If Result = -2 Then Return -1
			If Result = -3 Then Return  0
			If Result = -1 Then Return  1
			
			Return -2
End Sub
#End Region



#Region StripSemiBlank / StripSemiBlank2
Sub StripSemiBlank(StripFrom As String) As String  		'Ignore  Warning #12 - Not Used
	Return StripSemiBlank2(StripFrom, False) 
End Sub

Sub StripSemiBlank2(StripFrom As String, AddCRLF As Boolean) As String
        Dim NewString     As String = StripFrom
		
		
		If AddCRLF Then
		   NewString = StripFrom.Replace("; ", CRLF)
		   
		   Return NewString.Replace(";", CRLF)
		Else
'    	   Dim Location   As Int = StripFrom.IndexOf(";")
		   
		   Return NewString.Replace(";", " ")
		End If
End Sub
#End Region


